/*
 * Copyright (c) 2014-2016 ISPRAS (http://www.ispras.ru)
 * Institute for System Programming of the Russian Academy of Sciences
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * ee the License for the specific language governing permissions and
 * limitations under the License.
 */

#ifndef __LINUX_LDV_GFP_H
#define __LINUX_LDV_GFP_H

#include <linux/gfp.h>

#ifdef LDV_BITWISE
# define CHECK_WAIT_FLAGS(flags) (!(flags & __GFP_WAIT))
#else
# define CHECK_WAIT_FLAGS(flags) ((flags == GFP_ATOMIC) || (flags == GFP_NOWAIT))
#endif /* LDV_BITWISE */

#endif /* __LINUX_LDV_GFP_H */
